/*
 * px *
Copyright (c) 2008 Shawn Hladky

Permission is hereby granted, free of charge, to any person obtaining a copy of this software 
and associated documentation files (the "Software"), to deal in the Software without 
restriction, including without limitation the rights to use, copy, modify, merge, publish, 
distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the 
Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or 
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING 
BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
 */

#include "pxheaders.h"
#include "jobfiles_fixesclientuser.h"


void JobFiles_FixesClientUser::OutputStat(StrDict *out)
{
	// just throw the changelists into a set
	changes.insert(out->GetVar("Change")->Atoi());
}

std::list<int> JobFiles_FixesClientUser::GetChanges()
{
	// not sure this is totally necessary.  The docs for set imply that
	// it will automatically be sorted, but it's not explicit.
	// so I throw it into a list and sort anyway.
	std::list<int> sortedChanges;
	for(std::set<int>::const_iterator it = changes.begin(); it != changes.end(); it++) { 
		sortedChanges.push_back(*it);
	} 
	sortedChanges.sort();
	return sortedChanges;
}

void JobFiles_FixesClientUser::Debug()
{
	std::list<int> sortedChanges;
	int r = 0; 
	for(std::set<int>::const_iterator it = changes.begin(); it != changes.end(); it++) { 
		sortedChanges.push_back(*it);
		printf("%d\n", *it);
	} 
	sortedChanges.sort();

	for(std::list<int>::const_iterator it = sortedChanges.begin(); it != sortedChanges.end(); it++) { 
		printf("%d\n", *it);
	}
}