#include <clientapi.h>
#include <errornum.h>
#include "RBFilter.h"

RBFilter::RBFilter( ClientUser* u )
: ui( u )
{
	mode = Clear;
}

RBFilter::~RBFilter(void)
{
}

void RBFilter::Message( Error* err )
{
	if ( err->IsInfo() )
	{
		if ( mode == ErrorOnly ) return;

		char level = (char)err->GetGeneric() + '0';
		if ( level == '1' && mode == HideInfo1 ) return;
	}

	if ( mode == ErrorOnly && err->GetGeneric() == EV_EMPTY ) return;

	ui->Message( err );
}

void RBFilter::OutputStat( StrDict* varList )
{
	if ( mode == ErrorOnly ) return;

	ui->OutputStat( varList );
}
